#include "types.i"
#include "defns.i"
#include "extern.i"

int InNodeCount;
int InNodeChildCount;


CalcArity(Node)
Tree Node;
{
	DiscrValue v;
	    
	if ( Node->NodeType )
  {
		ForEach(v, 1, Node->Forks)
			CalcArity(Node->Branch[v]);
		InNodeCount++;
		InNodeChildCount += Node->Forks;	
	}
}

/*******************************************************************/
/*								                                                 */
/*		Calculate the average arity of a decision tree			         */
/*								                                                 */
/*******************************************************************/

float TreeArity(Node)
/*  ---------  */
    Tree Node;
{
		InNodeCount = 0;
		InNodeChildCount = 0;

		CalcArity(Node);

		if (InNodeCount)
			return InNodeChildCount/(float)InNodeCount;
		else
			return 0;
}


