#include "defns.i"
#include "types.i"
#include <string.h>

short		MaxAtt, MaxClass, MaxDiscrVal;
ItemNo		MaxItem;

Description	*Item;

DiscrValue	*MaxAttVal;

String		*ClassName,
		*AttName,
		**AttValName,
		FileName = "DF";

short		VERBOSITY = 0,
		TRIALS    = 10;

Boolean		GAINRATIO  = true,
		SUBSET     = false,
		BATCH      = false,
		UNSEENS    = false,
		PROBTHRESH = false;

ItemNo		MINOBJS   = 2,
		WINDOW    = 0,
		INCREMENT = 0;

float		CF = 0.10;

Tree		*Pruned;

Boolean		AllKnown = true;


char *FileName;

main(int Argc, char *Argv[])
{
	Boolean TRACCURACY = false, 
					ACCURACY = false,
					RANK = false,
					SIZE = false,
					ARITY = false;
	FILE *stats;
	int o;
  extern char *optarg;
  extern int optind;

	float TreeAccuracy(),TreeArity();
	int TreeRank(),TreeSize();

	Tree T;

	while ((o = getopt(Argc, Argv, "f:ausrt")) != EOF)
	{
		switch (o)
		{
			case 'f': FileName = optarg;
			printf("\tFile stem <%s>\n", FileName);
			break;
			case 'a': TRACCURACY = true;
			printf("Calculate training accuracy of the tree\n");
			break;
			case 'u': ACCURACY = true;
			printf("Calculate testing accuracy of the tree\n");
			break;
			case 's': SIZE = true;
			printf("Calculate Size of the tree\n");
			break;
			case 'r': RANK = true;
			printf("Calculate Rank of the tree\n");
			break;
			case 't': ARITY = true;
			printf("Calculate the arity of the tree\n");
			break;
		}		
	}

	GetNames();

	T = GetTree(".tree");
	
	PrintTree(T);

	if (ACCURACY || RANK || SIZE || TRACCURACY)
	{
		char Fn[128];
		strcpy(Fn,FileName);
		strcat(Fn,".stats");
		stats = fopen(Fn,"w");
	}

	if (TRACCURACY)
	{
		float accuracy; 
		GetData(".data");
		accuracy = TreeAccuracy(T);
		fprintf(stats,"TRACCURACY = %f\n",accuracy);
	}
	if (ACCURACY)
	{
		float accuracy; 
		GetData(".test");
		accuracy = TreeAccuracy(T);
		fprintf(stats,"ACCURACY = %f\n",accuracy);
	}

	if (RANK) fprintf(stats,"RANK = %d\n",TreeRank(T));
	if (SIZE) fprintf(stats,"SIZE = %d\n",TreeSize(T));
	if (ARITY) fprintf(stats,"ARITY = %f\n",TreeArity(T));

	if (stats) fclose(stats);
}
