/* program Nesting (input, output) */

#include "cseed.h"
#include "seed_scanline.h"

void Paren (int level, int *ends)
  {
  scan_positiontype here;
  char cc;

  scan_store(&here,*vstring_c("Paren"));
  do {
    *ends = 0;
    do {                /* read input a char at a time */
      cc = scan_char(scan_next());  if (scan_cancel()) goto cancel;
      scan_mark();
      if (cc == '.') {
        if (level > 0) {
          scan_used();
          ed_write(*vstring_c("There are still ")); ed_wrint(level);
          ed_write(*vstring_c("	open parentheses pending."));
          scan_error(); goto cancel;
          }
        else {
          *ends = 1;
          }
        }
      else if (cc == '(') {
        Paren(level+1, ends);     if (scan_cancel()) goto cancel;
        }
      else if (cc == ')') {
        if (level == 0) {
          scan_used();
          ed_write(*vstring_c("There is an excess of closing parens."));
          scan_error(); goto cancel;
          }
        }
      else if (cc == scan_eol) {
        scan_used();
        ed_wrint(level); ed_write(*vstring_c(": "));
        }
      }
    while (!( (cc == ')') || *ends));
    scan_exit();
  cancel: if (scan_cancel()) scan_restore(here);
    }
  while (!scan_done());
  }


int main (int argc, char *argv[])
  {
  int dummy;

  seed_init(argc, argv);
  scan_init();

  ed_write(*vstring_c("0: "));
  Paren(0, &dummy);

  seed_fini(0);
  
  return 9;   /* seed_fini will do an exit, this is never reached. */
  
  }
