{ argument.p
  Routines for acessing command line arguments.

  Author: Niklas Holsti  around 1994.7.28

  Version: Sun Pascal

}

module Arguments;

#include "strings_d.p"

private var
  argnum: integer;  { "File name" argument counter. }
  ddash : boolean;  { "--" found file scanning for file names. }

function Arg_Option (opt: vstring): boolean;
  { Checks if "opt" is an argument on the command line.
    If an argument is "--", remaining arguments are not
    checked.
  }
  var
    i: integer;   { count command line arguments }
    v: vstring;   { value of argument }
    y: boolean;   { yes, it is }
  begin
  y:= false;
  i:= 1;
  while (i < argc) and (not y) do begin
    argv(i,v);
    if      v = opt  then y:= true
    else if v = '--' then i:= argc
    else                  i:= i+1;
    end;
  Arg_Option:= y;
  end {Arg_Option};


function Arg_Count: integer;
  { Returns number of arguments. }
  begin
  Arg_Count:= argc;
  end {Arg_Count};


procedure Arg_FirstFile;
  { Resets the argument scanner to start from the first "file name"
    argument. Must always be called before the first Arg_NextFile. }
  begin
  argnum:= 1;
  ddash := false;
  end {Arg_FirstFile};

  
procedure Arg_NextFile (var name: vstring; var valid: boolean);
  { Gets the next "file name" (ie., not "-...") argument.
    If there are no more, returns valid = false.
    Remember to call Arg_FirstFile to start with, to reset the argument
    scanner.
  }
  begin
  valid:= false;
  while (argnum < argc) and (not valid) do begin
    argv(argnum, name);
    if      name = '--'      then ddash:= true
    else if length(name) = 0 then valid:= true
    else                          valid:= ddash or (name[1] <> '-');
    argnum:= argnum+1;
    end;
  end {Arg_NextFile};

