{ argument_f.p
  External declarations of routines in argument.p
}

function Arg_Option (opt: vstring): boolean;
  { Checks if "opt" is an argument on the command line.
    If an argument is "--", remaining arguments are not
    checked.
  }
  external;

function Arg_Count: integer;
  { Returns number of arguments. }
  external;

procedure Arg_FirstFile;
  { Resets the argument scanner to start from the first "file name"
    argument. Must always be called before the first Arg_NextFile. }
  external;

procedure Arg_NextFile (var name: vstring; var valid: boolean);
  { Gets the next "file name" (ie., not "-...") argument.
    If there are no more, returns valid = false.
    Remember to call Arg_FirstFile to start with, to reset the argument
    scanner.
  }
  external;
