{ console.p
  Routines that emulate the Turbo Pascal "console" unit.
  Used by the "unit test" programs.
}

module Console;

procedure CSI;
  begin
  write(chr(27),'[');
  end {CSI};

procedure GotoXY (col,row: integer);
  { Move cursor to given column and row. }
  begin
  CSI; write(row:1,';',col:1,'H');
  end {GotoXY};

procedure InsertLine;
  { Insert a new blank row at the current cursor position.
    Move rest of screen down one row. }
  begin
  CSI; write('1L');
  end {InsertLine};

procedure DeleteLine;
  { Delete current row, move rest up one row. }
  begin
  CSI; write('1M');
  end {DeleteLine};

procedure ClearEOL;
  { Erase from cursor to end of line, inclusive. }
  begin
  CSI; write('0K');
  end {ClearEOL};

procedure ClearScreen;
  { Erase entire screen. }
  begin
  CSI; write('2J');
  end {ClearScreen};
