{ Pascal translation of parts of /usr/include/sys/fcntl.h }

#if !defined(_FCNTL_P)
#define _FCNTL_P

const

	O_RDONLY	= 0	;
	O_WRONLY	= 1	;
	O_RDWR		= 2	;
	O_APPEND	= 16#008;
	O_CREAT		= 16#100;
	O_TRUNC		= 16#200;
	O_EXCL		= 16#400;
	O_NONBLOCK	= 16#080;
	O_NOCTTY	= 16#800;

	O_ACCMODE	= (O_RDONLY|O_WRONLY|O_RDWR);

{ XXX close on exec request; must match UF_EXCLOSE in user.h }
	FD_CLOEXEC	= 1;	{ posix }

{ fcntl(2) requests }
	F_DUPFD		=  0;	{ Duplicate fildes }
	F_GETFD		=  1;	{ Get fildes flags (close on exec) }
	F_SETFD		=  2;	{ Set fildes flags (close on exec) }
	F_GETFL		=  3;	{ Get file flags }
	F_SETFL		=  4;	{ Set file flags }

	F_SETLK  	=  6;	{ Set or Clear a record-lock (Non-Blocking) }
	F_SETLKW 	=  7;	{ Set or Clear a record-lock (Blocking) }
	F_GETLK  	= 14;	{ Get record-locking information }

{ fcntl(2) flags (l_type field of flock structure) }

	F_RDLCK		= 1;	{ read lock }
	F_WRLCK		= 2;	{ write lock }
	F_UNLCK		= 3;	{ remove lock(s) }

type

  flock_t = record
	l_type	: short;
	l_whence: short;
	l_start	: off_t;
	l_len	: off_t;
	l_pid   : pid_t;
	pad     : array[1..4] of long;
	end;
	

function sys_open (path: univ_ptr; flags: integer; mode: mode_t): integer;
  external;  { in unistd.p }


#endif
