{ keymap_f.p
  External declarations for routines in keymap.p
}

procedure Km_Explain (var f: text; result: Km_result);
  external;

procedure Km_NameFun (theFun: EditFun; name: vstring;
                      var result: Km_result);
  external;


procedure Km_Map (    theFun: EditFun;
                      keys  : vstring;
                  var result: Km_result);
  external;

procedure Km_Upcase (    prefix: vstring;
                     var result: Km_result);
  external;

procedure Km_ReadMap (var f: text;
                      var undef,ambig: boolean;
                      var result: Km_result);
  external;


procedure Km_GetFun (var theFun  : EditFun;
                     var textChar: char;
                         delay   : integer;
                     var timeout : boolean);
  external;

function KeyPressed: boolean;
  external;

function ReadChar: char;
  external;

procedure Km_Init;
  external;

procedure Km_Fini;
  external;

{ ** Testing routines ** }

procedure Km_ShowNames;
  { Display editor function name map structure. }
  external;

procedure Km_ShowKeys;
  { Display keystroke map structure. }
  external;

procedure Km_ShowPrefix;
  { Display buffered keystrokes and partial mapping, if any. }
  external;

procedure Km_ShowFunName (theFun: EditFun);
  { Display the defined name of an editing function. }
  external;
