{ render_f.p
  External declarations of render.p routines.
}
procedure Rn_Flush;
  { Make sure all data intended for screen get there, ie.
    dump buffer. }
  external;

function Rn_WriteC (c: char; filep: univ_ptr): integer;
  { Writes (buffers) one byte for the screen.
    The strange calling interface is designed to
    match the "terminfo" routine "tputs". }
  external;

procedure Rn_Raw  (data: vstring);
  { Output the data as such. No 'rendering'. }
  external;

procedure Rn_Text (txt : vstring; maxcol: integer; var actcol: integer);
  { Output the text, rendering normally unprintable characters in
    some visible way -- once this is implemented.
    Up to 'maxcol' screen columns are used; the number actually
    used is returned in actcol. For printable text, actcol = length(txt),
    or maxcol, whichever is smaller. }
  external;

procedure Rn_TextVar (var txt   : vstring;
                          first,len: integer;
                          maxcol: integer;
                      var actcol: integer);
  { Same as Rn_Text, but renders only txt[first .. first+len-1].
    Also avoids parameter copying, since the text is a 'var'. }
  external;

procedure Rn_Init;
  { Initialize module. }
  external;

procedure Rn_Fini;
  { Finalize module. }
  external;

