{ types_p.h
  POSIX and system types
}

#if !defined(_TYPES_P)
#define _TYPES_P

type
	short		= integer16;
	long		= integer32;
	u_short		= short;	{ should be unsigned short }
	u_int		= integer;	{ should be unsigned int }
	u_long		= long;		{ should be unsigned long }
	u_char		= char;		{ should be unsigned char }
	
	sigset_t	= record	{ signal mask - may change }
			  sigbits: array[0..3] of u_long;
			  end;
	tcflag_t	= u_long;	{ tty line disc modes }
	cc_t		= u_char;	{ tty control char }
	pid_t		= long;		{ process id }

	mode_t		= u_long;	{ file mode bits }
	nlink_t		= u_long;	{ links to a file }

	clock_t		= long;		{ units=ticks (typically 60/sec) }
	time_t		= long;		{ value = secs since epoch }

	size_t		= u_int;	{ len param for string funcs }


	caddr_t	= ^char;
	ino_t	= u_long;
	dev_t	= u_long;
	off_t	= long;
	uid_t	= long;
	gid_t	= uid_t;
	key_t	= integer;
	addr_t	= univ_ptr;

#endif
