{ Module unistd
  open, close, read, write renamed as sys_open, sys_close, sys_read, sys_write,
  to avoid conflict with Pascal statements.
  
  Niklas Holsti 1993.9.26
}

module unistd;

{ UNIX/POSIX routines from C library.
  In Solaris 2.x, these can no longer be declared as external inside the
  renamed functions, since they are then assigned composite linker names
  of the form sys_open.open etc.
}

function open (path: univ_ptr; flags, mode: integer): integer;
  external c;
function close (fildes: integer): integer;
  external c;
function read (fildes: integer; buf: univ_ptr; nbyte: integer): integer;
  external c;
function write(fildes: integer; buf: univ_ptr; nbyte: integer): integer;
  external c;

{ Rename as sys_... }

function sys_open (path: univ_ptr; flags, mode: integer): integer;
  begin
  sys_open:= open(path,flags,mode);
  end {sys_open};

function sys_close (fildes: integer): integer;
  begin
  sys_close:= close(fildes);
  end {sys_close};

function sys_read (fildes: integer; buf: univ_ptr; nbyte: integer): integer;
  begin
  sys_read:= read(fildes,buf,nbyte);
  end {sys_read};

function sys_write(fildes: integer; buf: univ_ptr; nbyte: integer): integer;
  begin
  sys_write:= write(fildes,buf,nbyte);
  end {sys_write};

