{ Pascal translation.

  close, read, write renamed as sys_close, sys_read, sys_write,
  to avoid conflict with Pascal statements.
  
  Last changed 93.2.17.
}

#if !defined(_UNISTD_P)
#define	_UNISTD_P

{ WARNING: _SC_CLK_TCK and sysconf() are also defined/declared in <time.h>. }

const
	_SC_ARG_MAX		= 1;	{ space for argv & envp }
	_SC_CHILD_MAX		= 2;	{ maximum children per process??? }
	_SC_CLK_TCK		= 3;	{ clock ticks/sec }
	_SC_NGROUPS_MAX		= 4;	{ number of groups if multple supp. }
	_SC_OPEN_MAX		= 5;	{ max open files per process }
	_SC_JOB_CONTROL		= 6;	{ do we have job control }
	_SC_SAVED_IDS		= 7;	{ do we have saved uid/gids }
	_SC_VERSION		= 8;	{ POSIX version supported }

	_POSIX_JOB_CONTROL	= 1;
	_POSIX_SAVED_IDS	= 1;
	_POSIX_VERSION		= 198808;

	_PC_LINK_MAX		= 1;	{ max links to file/dir }
	_PC_MAX_CANON		= 2;	{ max line length }
	_PC_MAX_INPUT		= 3;	{ max "packet" to a tty device }
	_PC_NAME_MAX		= 4;	{ max pathname component length }
	_PC_PATH_MAX		= 5;	{ max pathname length }
	_PC_PIPE_BUF		= 6;	{ size of a pipe }
	_PC_NO_TRUNC		= 7;	{ trunc or error on >NAME_MAX }
	_PC_VDISABLE		= 8;	{ best char to shut off tty c_cc }
	_PC_CHOWN_RESTRICTED	= 9;	{ can we give away files }
	_PC_LAST		= 9;	{ highest value of any _PC_* }

	STDIN_FILENO	= 0;
	STDOUT_FILENO	= 1;
	STDERR_FILENO	= 2;

	NULL	= 0;

{
 * lseek & access args
 }
	SEEK_SET	= 0;	{ Set file pointer to "offset" }
	SEEK_CUR	= 1;	{ Set file pointer to current plus "offset" }
	SEEK_END	= 2;	{ Set file pointer to EOF plus "offset" }


	F_OK		= 0;	{ does file exist }
	X_OK		= 1;	{ is it executable by caller }
	W_OK		= 2;	{ is it writable by caller }
	R_OK		= 4;	{ is it readable by caller }


#include "types_p.h"


type
  fdpair_t = array [0..1] of integer;
  
procedure _exit (status: integer);
  external c;
function access (path: univ_ptr; amode: integer): integer;
  external c;
function alarm (secs: integer): integer;
  external c;
function chdir (path: univ_ptr): integer;
  external c;
function chmod (path: univ_ptr; mode: mode_t): integer;
  external c;
function chown (path: univ_ptr; owner: uid_t; group: gid_t): integer;
  external c;
function sys_close (fildes: integer): integer;
  external; {Pascal!}
function ctermid (s: univ_ptr): univ_ptr;
  external c;
function cuserid (s: univ_ptr): univ_ptr;
  external c;
function dup (fildes: integer): integer;
  external c;
function dup2 (fildes,fildes2: integer): integer;
  external c;
function execv (path: univ_ptr; argv: univ_ptr): integer;
  external c;
function execve (path: univ_ptr; argv: univ_ptr; envp: univ_ptr): integer;
  external c;
function execvp (filp: univ_ptr; argv: univ_ptr): integer;
  external c;
function fork: pid_t;
  external c;
function fpathconf (fd: integer; name: integer): integer32;
  external c;
function getcwd (buf: univ_ptr; size: integer): univ_ptr;
  external c;
function getegid: gid_t;
  external c;
function geteuid: uid_t;
  external c;
function getgid: gid_t;
  external c;
function getgroups (gidsetsize: integer; grouplist: univ_ptr): integer;
  external c;
function getlogin: univ_ptr;
  external c;
function getpgrp: pid_t;
  external c;
function getpid: pid_t;
  external c;
function getppid: pid_t;
  external c;
function getuid: uid_t;
  external c;
function isatty (fildes: integer): integer;
  external c;
function link (path1,path2: univ_ptr): integer;
  external c;
function lseek (fildes: integer; offset: off_t; whence: integer): off_t;
  external c;
function pathconf (path: univ_ptr; name: integer): integer32;
  external c;
function pause: integer;
  external c;
function pipe (var fildes: fdpair_t): integer;
  external c;
function sys_read (fildes: integer; buf: univ_ptr; nbyte: integer): integer;
  external; {Pascal!}
function sys_write(fildes: integer; buf: univ_ptr; nbyte: integer): integer;
  external; {Pascal!}
function rmdir (path: univ_ptr): integer;
  external c;
function setgid (gid: gid_t): integer;
  external c;
function setpgid (pid,pgid: pid_t): integer;
  external c;
function setsid: pid_t;
  external c;
function setuid (uid: uid_t): integer;
  external c;
function sleep (seconds: integer): integer;
  external c;
function sysconf (name: integer): integer32;
  external c;
function tcgetpgrp (fildes: integer): pid_t;
  external c;
function tcsetpgrp (fildes: integer; pgrp_id: pid_t): integer;
  external c;
function ttyname (fildes: integer): univ_ptr;
  external c;
function unlink (path: univ_ptr): integer;
  external c;

#endif	{ !_unistd_h }
