program Balance (input,output);
{ Checks that each input paragraph has balanced parentheses. }

#include "strings_d.p"
#include "edit_d.p"
#include "edit_f.p"
#include "scanline_d.p"
#include "scanline_f.p"


procedure Paren (level: integer);
  { We have just seen a '('. Scan input for the matching ')' or
    end of paragraph (empty line). }
  label 66;
  var
    safe: Scan_PositionType;
    ind : ScriptIndex;         { next input position }
    cc  : char;                { the input symbol there }
    clp : boolean;             { a closing paren found }
  begin
  Scan_Store(safe,'Paren');
  repeat  { from safe point }
    ind:= Scan_Next;
    repeat  { scan input char }
      cc := Scan_Char(ind);         if Scan_cancel then goto 66;
      clp:= cc = ')';
      if cc = '(' then begin
        Paren (level+1);            if Scan_cancel then goto 66;
        ind:= Scan_Next;
        end
      else if clp and (level = 0) then begin
        Scan_Used;
        Ed_Write('Too many ")"s.'); Ed_WriteLn;
        Scan_Error;
        goto 66;
        end
      else if cc = Scan_eol then begin
        Scan_Used;
        Ed_Write('['); Ed_WrInt(level); Ed_Write('] ');
        ind:= Scan_Next;
        cc := Scan_Char(ind);      if Scan_cancel then goto 66;
        if cc = Scan_eol then begin  { a blank line }
          if level > 0 then begin
            Scan_Used;
            Ed_Write('The preceding paragraph contains unbalanced parentheses.');
            Ed_WriteLn;
            if level = 1 then Ed_Write('There is one extra "(".')
            else begin
              Ed_Write('There are '); Ed_WrInt(level);
              Ed_Write(' extra "("s.');
              end;
            Ed_WriteLn;
            Scan_Error;
            goto 66;
            end;
          { ind is left as is, so cc is reprocessed within this para. }
          end { blank line };
        end { eol }
      else
        ind:= Scan_Next;   { nothing special, look at next char. }
    until (cc = Scan_eol)  { end of para }
       or (clp          ); { end of ()   }
    Scan_exit;
  66: if Scan_cancel then Scan_Restore(safe);
  until Scan_done;
  end {Paren};


procedure Paragraphs;
  label 66;
  var
    safe: Scan_PositionType;
  begin
  Scan_Store(safe,'Paragraph');
  Ed_Write('[P] ');
  repeat
    Paren(0);                       if Scan_cancel then goto 66;
    Paragraphs;
    Scan_exit;
  66: if Scan_cancel then Scan_Restore(safe);
  until Scan_done;
  end {Paragraphs};

begin { Test }

Ed_Init;
Scan_Init;

Paragraphs;

Ed_Fini;

end {Balance}.


