{  A test program for incremental (reversible) script
   execution under a SEED-like session editor - lists lexical
   tokens as they come. }

program Tokenlist (input,output);

#include "seed_p.h"

type

  SymbolType       = (BeginSymbol, EndSymbol);

procedure Tokens;
  label 66;
  var
    here : Lex_PositionType;
    mrk  : vstring;
  begin
  Lex_Store(here {,'Tokens'});
  repeat
    Lex_Get;                         if Lex_cancel then goto 66;
    with Lex_token do
    case kind of
      NullToken      : Ed_write('Null token');
      CancelSignal   : Ed_write('Cancel signal');
      NatNumToken    : begin
                       Ed_write('Natnumber: ');
                       Ed_wrint(natnumber);
                       end;
      RealNumToken   : begin
                       Ed_write('Realnumber: ');
                       Ed_wrreal(realnumber,15,8);
                       end;
      MarkToken      : begin
                       Ed_write('Mark "');
                       mrk:=character;
                       Ed_write(mrk);
                       Ed_write('"');
                       end;
      SymbolToken    : begin
                       Ed_write('Symbol number ');
                       Ed_wrint(symnum);
                       end;
      WordToken      : begin
                       Ed_write('Word "');
                       Ed_write(word);
                       Ed_write('"');
                       end;
      StringToken    : begin
                       Ed_write('String between "');
                       mrk:=opener; Ed_write(mrk);
                       Ed_write('" and "');
                       mrk:=closer; Ed_write(mrk);
                       Ed_write('": "');
                       Ed_write(quoted);
                       Ed_write('"');
                       end;
      EolToken       : Ed_write('Eol');
      EolCommentToken: Ed_write('EolComment');
      EofToken       : Ed_write('Eof');
      end;

    Ed_writeln;

    Lex_Null;
    Tokens;            if Lex_cancel then goto 66;
    Lex_exit;
  66: if Lex_cancel then Lex_Restore(here);
  until Lex_done;
  end {Tokens};


procedure TokenlistInit;
  begin
  Lex_Define('end-it',ord(EndSymbol));
  Lex_Define('begin-this',ord(BeginSymbol));
  Lex_BodyChar (NatNumToken,Lex_Include,'_');
  Lex_QuotePair('(',')');
  Lex_QuotePair('{','}');
  Lex_FirstChar(StringToken,Lex_Set,'^({');
  Lex_BlankChar(Lex_Include,'*');
  Lex_BodyChar(SymbolToken,Lex_Exclude,'xyz');
  Lex_BodyChar(SymbolToken,Lex_Include,'-');
  Lex_FirstChar(EolCommentToken,Lex_Set,'#');
  Lex_BodyChar (EolCommentToken,Lex_Set,' ');
  end {TokenlistInit};

begin { TokenList }

Seed_Init;

Ed_write('List tokens as they come.'); Ed_writeln;
Ed_write('To quit, type ctrl-X ctrl-C.'); Ed_writeln;
Ed_writeln;
TokenlistInit;
Tokens;

Seed_Fini;

end {Tokenlist}.

