{ edit_d.p
  Constants and types for edit.p

  Changes:
    94.07.27  AbortMsg added.
    94.08.03  Touched, no real changes.
}

const
  Ed_maxLine = 200;  { line length limit (Ed_Getln routine) }

type

  Ed_LineType  = packed array [1..Ed_maxLine] of char;

  ScriptIndex = integer;  { transcript input symbol count }

  Ed_ExecMode = (  { How a transcript is processed, if at all }
      NoExec,        { dead text file, no processing }
      ManExec,       { process line by line, no cancel, no status }
      JobExec,       { process job steps in sequence }
      IncExec        { process incrementally, cancel, status known }
      );

  MsgKind = (
       NoMsg,           { no message yet (internal to Edit) }
       ProcessMsg,      { text to process }
       CancelMsg,       { reverse processing }
       AbortMsg         { abort processing }
       );

  Ed_MsgType = record
    case kind: MsgKind of
      NoMsg     : ();
      ProcessMsg: (processfrom: ScriptIndex;  { Index of start of text }
                   eoln,eof   : boolean;
                   data       : vstring    );
      CancelMsg : (cancelto   : ScriptIndex); { Index to reverse to }
      AbortMsg  : ();
      end {Ed_MsgType};
