# Default keymap file for editor.
# N. Holsti 91.04.07
#           92.04.11 del for backspace.
#           94.03.20 ^X D to write transcript.
#           94.04.05 esc < and esc > to go to top/bottom
#                    delete Mac keys
#           94.06.22 ^X ^D synonym to write transcript, also others.
#           94.10.01 view-transcript added (^X^V).

# Upper-case conversion of letters after the following prefixes:
<>               esc
<>               ^X

insert
overstrike
text
newline          ^J
delchar          esc ^H
backspace        ^H
   "             del
joinline         ^X ^M

# ANSI terminal cursor keys (7- and 8-bit)
left             esc [ D
  "              csi   D
right            esc [ C
  "              csi   C
up               esc [ A
  "              csi   A
down             esc [ B
  "              csi   B
#--

bakw
forw
endleft          ^A
endright         ^E
pageup           ^P
  "              ^Z
  "              esc [ 5 ~
  "              csi   5 ~
pagedown         ^N
  "              ^V
  "              esc [ 6 ~
  "              csi   6 ~
go-top           esc <
go-bot           esc >
search           esc S
replace          esc R
mark             esc sp
cut              ^W
copy             esc W
paste            ^Y

open-window      ^X 2
close-windows    ^X 1
next-window      ^X O        # that's a letter "oh"
next-transcript  ^X X
new-transcript   ^X ^F
view-transcript  ^X ^V

refresh-screen   ^L

write-transcript ^X D
  "              ^X ^D
write-input      ^X J
  "              ^X ^J
write-text       ^X T
  "              ^X ^T
read-insert      ^X ^I
  "              ^X ^R
name-file        ^X N

process-char     ^M             # CR
  "              esc [ 2 9 ~    # "Do" key on VT200
  "              csi   2 9 ~
process-line
process-end      esc ^M
  "              esc esc [ 2 9 ~
  "              esc csi   2 9 ~
process-item

abort-process    ^G
complete-input   ^I
query-completions ^D	

exit             esc Z
quit             ^X ^C

logmore         esc M
logless         esc L
logwindow       esc ? W
logscript       esc ? S
spotcheck       esc ? C
whereline       esc ? L
