/*                                                                            *\

	  TELA - Testing Environment for Learning Algorithms - version 1.995
    ==================================================================

		Module:       DFD.l

		Contents:     Lex analyzer sources for Algorithm Database
 
		Author:				Juho Rousu (1995,1996)

\*  																																					*/
 
%{
	#include "y.tab.h"
	#include "Alg_Database.h"
	int lines = 1;
	char buf[256];
	char err_str[256];
%}
%%
#.*$ 			  ;
[ \t] ;
\[OPTIONS\]		return OPTIONS;
\[RUNSTATS\] return RUNSTATS;
\[TESTSTATS\] return TESTSTATS;
\[ATTRIBUTES\] return ATTRIBUTES;
\[EXAMPLES\]	return EXAMPLES;
\[INTERFACE\]	return INTERFACE;
ATTSEXSFILES	return AE_FILE_SUPPORT;
CLASS					return CLASS;
BOTHHEADER		return BOTHHEADER;
ATTSHEADER 		return ATTSHEADER;
EXSHEADER			return EXSHEADER;
RULEHEADER		return RULEHEADER;
ATTSFOOTER		return ATTSFOOTER;
EXSFOOTER			return EXSFOOTER;
BOTHFOOTER		return BOTHFOOTER;
RULEFOOTER		return RULEFOOTER;
GRAMMAR				return GRAMMAR;
ATTSEP				return ATTSEP;
NUMATTSEP			return NUMATTSEP;
NAMEVALSEP		return NAMEVALSEP;
TYPEVALSEP		return TYPEVALSEP;
VALSEP				return	VALSEP;
NOMINAL				return NOMINAL;
INT						return	INT;
COMMENTSEP		return COMMENTSEP;
CONT					return	CONT;
UNKNOWN				return	UNKNOWN;
DONTCARE			return	DONTCARE;
FIRSTCHARSET	return	FIRSTCHARSET;
CHARSET				return	CHARSET;
EXVALSEP			return EXVALSEP;
EXAMPLESEP		return EXAMPLESEP;
ATTSEXSSEP		return ATTSEXSSEP;
EXENAME				return EXENAME;
OPTIONS				return OPTIONS;
ATTSEXT				return ATTSEXT;
EXSEXT				return EXSEXT;
BOTHEXT				return BOTHEXT;
RULEEXT				return RULEEXT;
BEGIN					return T_BEGIN;
END						return END;
DESCRIPTION		return DESCRIPTION;
LAST					return LAST;
FIRST					return FIRST;
UNNAMED				return UNNAMED;
EOL						return EOL_TOKEN;
FULL					return FULL;
NULL					return T_NULL;
ALPHA					return ALPHA;
BLANK					return BLANK;
DEFAULTS      return DEFAULTS;
RULETYPE      return RULETYPE;
"|"						return OR;
"="						return EQUALS;
\n						{	
								lines++;
								return NEWLINE;
							}

['][^']*['] {
		strcpy(buf,yytext);
		return QUOTED;
}

[a-zA-Z;\.:,0-9][a-zA-Z;\.:,0-9]*	{		
		strcpy(buf,yytext);
		return STRING;
	};
%%								
yyerror(char *str)
{
		printf("Error: %s on line %d: %s\n",str,lines,yytext);
		ADB_parser_rv = PARSE_FAILED;
}

