#ifndef H_TELA_DL_ROUTINES
#define H_TELA_DL_ROUTINES

/*                                                                            *\

	  TELA - Testing Environment for Learning Algorithms - version 1.995
    ==================================================================

		Module:       DL_routines

		Contents:			Data logging routines of TELA. Generate an attribute
									description for a raw example set

		Services:

		DL_gen_attr_descr   - generate the attribute description from inference
													results
		DL_display_inference_stats - print inference statistics to stdout

		Author:       Juho Rousu (1995,1996)

\*                                                                            */ 
#include "tela.h"

typedef struct
{
	t_attr_types a_type;	
	int val_count;
	int d_val_cnt;
	int i_val_cnt;
	int f_val_cnt;	
	float low;
	float high;
} t_dl_node;

int DL_display_inference_stats(t_dl_node *p_dl_data, int ex_cnt);

int DL_gen_attr_descr(t_algorithms alg, char *exs_file, 
	int th, t_dl_node **dl_data, int *ex_cnt);

#endif
