#ifndef H_TELA_TESLA_EXEC_CMDS
#define H_TELA_TESLA_EXEC_CMDS

/*                                                                            *\

	  TELA - Testing Environment for Learning Algorithms - version 1.995
    ==================================================================

		Module:  TESLA_IO_cmds (part of TESLA command server)

		Contents: File system I/O related commands of TESLA language

		Services:

		READ_ATTS_command - reads an attribute description file
		READ_EXS_command  - reads an example vector file
		READ_BOTH_command - reads a combined atts/exs -file 
		READ_command      - a wrapper for above READ variants
		READ_RULE_command - reads a rule file

		WRITE_ATTS_command - writes an attribute description file
		WRITE_EXS_command  - an example vector file
		WRITE_BOTH_command - a combined atts/exs -file 
		WRITE_command      - a wrapper for above WRITE variants
		WRITE_RULE_command - writes a rule file

		Author: Margareta Bjorksten, Marko Nyman (1992), 
						Juho Rousu (1995,1996)
\*                                                                            */

#include "UI_parsers.h"

int READ_ATTS_command (t_command p);
int READ_EXS_command(t_command p); 
int READ_BOTH_command (t_command p);
int READ_command (t_command p);
int READ_RULE_command(t_command params);

int WRITE_ATTS_command (t_command p);
int WRITE_EXS_command (t_command p);
int WRITE_BOTH_command(t_command p);
int WRITE_command (t_command p);
int WRITE_RULE_command (t_command params);

#endif
