#ifndef H_TELA_STATISTICS
#define H_TELA_STATISTICS

/*                                                                            *\

	  TELA - Testing Environment for Learning Algorithms - version 1.995
    ==================================================================

		Module:       TESLA_statistics.h

		Contents:    Statistics handling and output routines.	
								 
		Services:

		STATS_check_for_uncollected   - check whether some stats are not collected
		STATS_copy_list								- make a copy of a statistics list
		STATS_create_node 						- create a statistics node
		STATS_merge_lists							- merge to statistics lists
		STATS_open_file								- open statistics file for append
		STATS_write_file							- write parameters and statistics to file
		STATS_print_parameters				- print parametres to file
		STATS_update_node							- update a statistics node
		STATS_update_from_avg					- update stats from a list of avg. stats
		STATS_write_line							- write a line to the statsitics file
		STATS_delete_list							- delete the statistics list
		STATS_find_node								- find a statistics node

		Author: Juho Rousu (1995,1996)
\*  																																					*/
   
#include "UI_parsers.h"

/* statistics printing modes */
#define S_NO       -1
#define S_ONLY_AVG 0
#define S_ONLY_IND 1
#define S_BOTH     2


t_stats_node *STATS_create_node(char *name);
int STATS_merge_lists(t_algorithms alg,int mode, t_stats_list *p_list1,
 	t_stats_list *p_list2);
void STATS_print_parameters(char *cmd_string,int rounds,t_algorithms alg,
	t_run_node *param_list, FILE* s_file,char *comment);
int STATS_update_node(t_stats_list *p_stats,char *stat_name,float value);
void STATS_update_from_avg(float round,t_stats_list *p_list1, 
	t_stats_list *p_list2);
int STATS_write_file(char *cmd_str,int rounds, t_algorithms alg, int in_do, 
	int mode, t_run_node *p_params, char *comment,char *file_name, 
	t_stats_list *p_list);
void STATS_write_line(char *file_name,char *line);
FILE *STATS_open_file(char *stat_file_name);
int STATS_copy_list(t_algorithms alg,int mode,
	t_stats_list *p_list1, t_stats_list *p_list2,int printing);
void STATS_delete_list(t_stats_list *p_stats);
int STATS_check_for_uncollected(t_stats_list *p_stats);
int STATS_find_node(t_stats_list *p_stats,char *stat_name, 
	t_stats_node **pp_node);




#endif
