#ifndef H_TELA_CHKPNT
#define H_TELA_CHKPNT

/*                                                                            *\

	  TELA - Testing Environment for Learning Algorithms - version 1.995
    ==================================================================

		Module:       UI_chk_pnt.h

		Contents:     Checkpoint maintenance routines for SEED interface
									 
		Services:

		new_chk_pnt         - add a new checkpoint
		free_chk_pnt        - free a checkpoint
		free_cmd_list		    - free a list of commands
		cmd_type					  - return the type of the command
		add_cmd_list			  - add a command at the end of the  command list
		*cmd_name						- return the name of the command
		insert_to_cmd_list	- insert a command at the beginning of the command list

		Author: Juho Rousu (1995,1996)
\*  																																					*/
   
#include <stdio.h>

#include "cseed.h"
#include "seed_lexline.h"
#include "UI_parsers.h"

typedef enum {C_WSMANIP,C_PROCESSING} t_cmd_type;

typedef struct s_chk_pnt 
{
	t_cmd_type cp_type;						/* type of commands in this block     			*/
	t_command *p_cmds;						/* commands in this block             			*/
	boolean unsafe;               /* reversing to this is not possible        */
	
	lex_positiontype lex_pos;			/* position where to reverse to							*/
	t_command *p_rev_cmds;				/* commands to execute when reversing				*/
	boolean ae_backup;          			/* attrs backed up in this block    		*/
	boolean cf_backup;								/* cf backed up in this block       		*/

	struct s_chk_pnt *p_prev;		  /* previous checkpoint											*/	
} t_chk_pnt;


int new_chk_pnt(t_chk_pnt **pp_chk_pnt,t_cmd_type c_type,lex_positiontype lp);
void free_chk_pnt(t_chk_pnt **pp_chk);
void free_cmd_list(t_command **pp_cmd);
t_cmd_type cmd_type(t_command *p_cmd);
void add_cmd_list(t_command **pp_list,t_command *p_cmd);
char *cmd_name(t_command *p_cmd);
void insert_to_cmd_list(t_command **pp_list1,t_command *p_list2);

#endif
