/*                                                                            *\

	  TELA - Testing Environment for Learning Algorithms - version 1.995
    ==================================================================

		Module:       UI_parsers

		Contents:     Parsers of TESLA commands for SEED interface  

		Services:

		

		Author: Ilkka Hyvrinen (1992,1993,1994) Juho Rousu (1995,1996)

\*                                                                            */

#ifndef H_TELA_UI_PARSERS
#define H_TELA_UI_PARSERS

#include "tela.h"

typedef enum 
{
  class_sym,
  div_sym,
  do_sym,
  dump_sym,
  end_sym,
  excl_sym,
  incl_sym,
  map_sym,
  noise_sym,
  quit_sym,
  rand_sym,
  read_sym,
  stat_sym,
  write_sym,   
	run_sym,   	
	test_sym,      
	cv_sym,
	delete_sym,
	select_sym,
	set_sym,
	init_sym,

	atts_sym, 
	exs_sym, 
	both_sym, 
	rule_sym,
	randseed_sym,
	algorithm_sym, 

	others_sym, 
	except_sym, 
	as_sym, 
	else_sym, 
	all_sym, 
	into_sym, 
	comment_sym, 
	record_sym, 
	not_sym,
	in_sym,
	none_sym,
	clock_sym,

	time_sym, 
	size_sym, 
	rank_sym, 
	testtime_sym, 
	accuracy_sym, 
} t_symbol;


t_command *alloc_cmd();
t_command *free_cmd(t_command *,int);
void commit_cmd(t_command**,t_command*);



#endif
